#!/usr/bin/perl -w
# ----------------------------------------------------------------------------
#  test_pq.pl
#          Pg.pm
# ----------------------------------------------------------------------------

use strict;
use Pg;                 #  ()    PostgreSQL
use constant DBNAME => 'test';   #   

my $conn;               #     
my $result;             #   SQL-
my @row;                #       
my $command;            #  SQL-    

#    
$conn = Pg::connectdb( "dbname=" . DBNAME . " user=postgres" );

#   
die $conn->errorMessage unless PGRES_CONNECTION_OK eq $conn->status;

#  SQL-    :
#      Students
# (     name)
$command = "SELECT * FROM students " .
           "ORDER BY name";

#     
$result = $conn->exec( $command );

#         
if ( PGRES_TUPLES_OK ne $result->resultStatus )
{
  die $conn->errorMessage;  #  
}

#       
if ( $result->ntuples == 0 )
{
  print "  Students  \n";
  return ( 0 );
}

#  
printf "%-12s", ". ";
printf "%-30s", ". . .";
printf "%-12s", " .";
printf "%-12s", " .";
print "\n\n";

#      
#  fetchrow       
while ( @row = $result->fetchrow )
{
  #  fnumber     ,
  # . .  ,    
  # (     
  #       ,    
  #        )
  printf "%-12s", $row[ $result->fnumber( 'mark_book' ) ];
  printf "%-30s", $row[ $result->fnumber( 'name' ) ];
  printf "%-12s", $row[ $result->fnumber( 'psp_ser' ) ];
  printf "%-12s", $row[ $result->fnumber( 'psp_num' ) ];
  print "\n";
}
exit ( 0 );
