#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :   CGI-   PostgreSQL
# -----------------------------------------------------------------------------

use strict;
use CGI;

#        
use CGI::Carp qw( fatalsToBrowser );

use Pg;                          #    PostgreSQL
use constant DBNAME => 'test';   #   

#        
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $conn;                        #     
my $query = CGI->new();          #  CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

print $query->header();       # HTTP-
print $query->start_html();   # HTML-

#    
$conn = Pg::connectdb( "dbname=" . DBNAME . " user=postgres" );

#   
die $conn->errorMessage 
  unless PGRES_CONNECTION_OK eq $conn->status;

#    ""
if ( $query->param( 'add_student' ) )  
{
  #     Students
  add_student( $conn, $query );
}

#    "  "
if ( $query->param( 'show_db' ) )
{
  #    
  show_db( $conn, $query );
}

#    HTML
print $query->end_html();

exit ( 0 );

sub show_db
{
  my $conn = shift;   #     
  my $q = shift;      # CGI-

  my $result;         #   SQL-
  my @row;            #       
  my $command;        #  SQL-    

  #  SQL-    
  $command = "SELECT * FROM students " .
             "ORDER BY name";

  #     
  $result = $conn->exec( $command );

  #         
  if ( PGRES_TUPLES_OK ne $result->resultStatus )
  {
    die $conn->errorMessage;  #  
  }

  #       
  if ( $result->ntuples == 0 )
  {
    print "  Students  \n";
    return ( 0 );
  }

  #     
  print "<TABLE BORDER WIDTH = 100%>\n";
  print "<TR>\n";
  print "<TD>  </TD>\n";
  print "<TD>, , </TD>\n";
  print "<TD> </TD>\n";
  print "<TD> </TD>\n";
  print "</TR>\n";

  #      
  #  fetchrow       
  while ( @row = $result->fetchrow )
  {
    print "<TR>\n";

    #      
    print "<TD>$row[ $result->fnumber( 'mark_book' ) ]</TD>\n";
    print "<TD>$row[ $result->fnumber( 'name' ) ]</TD>\n";
    print "<TD>$row[ $result->fnumber( 'psp_ser' ) ]</TD>\n";
    print "<TD>$row[ $result->fnumber( 'psp_num' ) ]</TD>\n";
    print "</TR>\n";
  }
  print "</TABLE>\n";

  return 0;
}

sub add_student
{
  my $conn = shift;   #     
  my $q = shift;      # CGI-

  my $result;         #   SQL-
  my $command;        #  SQL-    

  #  SQL-    
  # (     )
  $command = "INSERT INTO students " .
                   "( mark_book, name, psp_ser, psp_num ) " .
             "VALUES( " . $q->param( 'mark_book' ) . ", " .
                      "'" . $q->param( 'name' ) . "', " .
                      "'" . $q->param( 'psp_ser' ) . "', " .
                      $q->param( 'psp_num' ) . " )";

  #         
  # print "$command<BR><BR>\n";

  #     
  $result = $conn->exec( $command );

  #         
  if ( PGRES_COMMAND_OK ne $result->resultStatus )
  {
    die $conn->errorMessage;
  }
  else
  {
    print "    <BR>\n";
  }

  return 0;
}
